internal::reservable_predecessor_cache< T, M > Class Template Reference

An cache of predecessors that supports requests and reservations. More...

`#include <_flow_graph_cache_impl.h>`

Inheritance diagram for internal::reservable_predecessor_cache< T, M >:
Collaboration diagram for internal::reservable_predecessor_cache< T, M >:

## Public Types

typedef M | mutex_type
typedef T | output_type
typedef sender< T > | predecessor_type
typedef receiver< T > | successor_type
Public Types inherited from internal::predecessor_cache< T, M >
typedef M | mutex_type
typedef T | output_type
typedef sender< output_type > | predecessor_type
typedef receiver< output_type > | successor_type
Public Types inherited from internal::node_cache< sender< T >, M >
typedef size_t | size_type

## Public Member Functions

| reservable_predecessor_cache ()
bool | try_reserve (output_type &v)
bool | try_release ()
bool | try_consume ()
void | reset ()
void | clear ()
Public Member Functions inherited from internal::predecessor_cache< T, M >
| predecessor_cache ()
void | set_owner (successor_type *owner)
bool | get_item (output_type &v)
void | reset ()
Public Member Functions inherited from internal::node_cache< sender< T >, M >
bool | empty ()
void | add (sender< T > &n)
void | remove (sender< T > &n)
void | clear ()

## Private Attributes

predecessor_type * | reserved_src

## Additional Inherited Members

Protected Types inherited from internal::node_cache< sender< T >, M >
typedef M | mutex_type
Protected Member Functions inherited from internal::node_cache< sender< T >, M >
bool | internal_empty ()
size_type | internal_size ()
void | internal_push (sender< T > &n)
sender< T > & | internal_pop ()
Protected Attributes inherited from internal::predecessor_cache< T, M >
successor_type * | my_owner
Protected Attributes inherited from internal::node_cache< sender< T >, M >
mutex_type | my_mutex
std::queue< sender< T > * > | my_q

## Detailed Description

### template<typename T, typename M = spin_mutex>
class internal::reservable_predecessor_cache< T, M >

An cache of predecessors that supports requests and reservations.

Definition at line 197 of file _flow_graph_cache_impl.h.

## Member Typedef Documentation

## mutex_type

template<typename T, typename M = spin_mutex>

typedef M internal::reservable_predecessor_cache< T, M >::mutex_type

Definition at line 199 of file _flow_graph_cache_impl.h.

## output_type

template<typename T, typename M = spin_mutex>

typedef T internal::reservable_predecessor_cache< T, M >::output_type

Definition at line 200 of file _flow_graph_cache_impl.h.

## predecessor_type

template<typename T, typename M = spin_mutex>

typedef sender<T> internal::reservable_predecessor_cache< T, M >::predecessor_type

Definition at line 205 of file _flow_graph_cache_impl.h.

## successor_type

template<typename T, typename M = spin_mutex>

typedef receiver<T> internal::reservable_predecessor_cache< T, M >::successor_type

Definition at line 206 of file _flow_graph_cache_impl.h.

## Constructor & Destructor Documentation

## reservable_predecessor_cache()

template<typename T, typename M = spin_mutex>

internal::reservable_predecessor_cache< T, M >::reservable_predecessor_cache | ( |  | ) |

inline

Definition at line 209 of file _flow_graph_cache_impl.h.

: reserved_src(NULL) { }

## Member Function Documentation

## clear()

template<typename T, typename M = spin_mutex>

void internal::reservable_predecessor_cache< T, M >::clear | ( |  | ) |

inline

Definition at line 260 of file _flow_graph_cache_impl.h.

{
reserved_src = NULL;
predecessor_cache<T,M>::clear();
}

Referenced by internal::reserving_port< T >::reset_receiver().

Here is the caller graph for this function:

## reset()

template<typename T, typename M = spin_mutex>

void internal::reservable_predecessor_cache< T, M >::reset | ( |  | ) |

inline

Definition at line 255 of file _flow_graph_cache_impl.h.

{
reserved_src = NULL;
predecessor_cache<T,M>::reset( );
}

Referenced by internal::reserving_port< T >::reset_receiver().

Here is the caller graph for this function:

## try_consume()

template<typename T, typename M = spin_mutex>

bool internal::reservable_predecessor_cache< T, M >::try_consume | ( |  | ) |

inline

Definition at line 249 of file _flow_graph_cache_impl.h.

{
reserved_src->try_consume( );
reserved_src = NULL;
return true;
}

Referenced by internal::reserving_port< T >::handle_operations().

Here is the caller graph for this function:

## try_release()

template<typename T, typename M = spin_mutex>

bool internal::reservable_predecessor_cache< T, M >::try_release | ( |  | ) |

inline

Definition at line 242 of file _flow_graph_cache_impl.h.

{
reserved_src->try_release( );
reserved_src = NULL;
return true;
}

Referenced by internal::reserving_port< T >::handle_operations().

Here is the caller graph for this function:

## try_reserve()

template<typename T, typename M = spin_mutex>

bool internal::reservable_predecessor_cache< T, M >::try_reserve | ( | output_type & | v | ) |

inline

Definition at line 212 of file _flow_graph_cache_impl.h.

{
bool msg = false;
do {
{
typename mutex_type::scoped_lock lock(this->my_mutex);
if ( reserved_src || this->internal_empty() )
return false;
reserved_src = &this->internal_pop();
}
// Try to get from this sender
msg = reserved_src->try_reserve( v );
if (msg == false) {
typename mutex_type::scoped_lock lock(this->my_mutex);
// Relinquish ownership of the edge
reserved_src->register_successor( *this->my_owner );
reserved_src = NULL;
} else {
// Retain ownership of the edge
this->add( *reserved_src );
}
} while ( msg == false );
return msg;
}

Referenced by internal::reserving_port< T >::handle_operations().

Here is the caller graph for this function:

## Member Data Documentation

## reserved_src

template<typename T, typename M = spin_mutex>

predecessor_type* internal::reservable_predecessor_cache< T, M >::reserved_src

private

Definition at line 266 of file _flow_graph_cache_impl.h.

The documentation for this class was generated from the following file:

- _flow_graph_cache_impl.h

internal::node_cache< sender< T >, M >::add
void add(sender< T > &n)
Definition: _flow_graph_cache_impl.h:40
internal::node_cache< sender< T >, M >::internal_empty
bool internal_empty()
Definition: _flow_graph_cache_impl.h:97
internal::node_cache< sender< T >, M >::internal_pop
sender< T > & internal_pop()
Definition: _flow_graph_cache_impl.h:112
internal::node_cache< sender< T >, M >::my_mutex
mutex_type my_mutex
Definition: _flow_graph_cache_impl.h:90
internal::node_cache< sender< T >, M >::clear
void clear()
Definition: _flow_graph_cache_impl.h:54
internal::reservable_predecessor_cache::reserved_src
predecessor_type * reserved_src
Definition: _flow_graph_cache_impl.h:266
lock
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task __itt_model_task_instance ITT_FORMAT p void * lock
Definition: ittnotify_static.h:121
internal::predecessor_cache::reset
void reset()
Definition: _flow_graph_cache_impl.h:173
internal::predecessor_cache::my_owner
successor_type * my_owner
Definition: _flow_graph_cache_impl.h:191

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.